Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDocumentStatisticsActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDocumentStatisticsActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDocumentStatisticsActionBuilderModuleFactory.java	(revision 39157)
@@ -36,10 +36,11 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 */
 		public DocumentToDocumentStatisticsActionBuilderModule(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -80,17 +81,18 @@
 //			fallback
 			return null;
 		}
-
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 	
 		@Override
 	public ActionBuilderModule<DocumentToDocumentStatistics> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentToDocumentStatisticsActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+		
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
+
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/AbstractActionManagerBasedExporterMapper.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/AbstractActionManagerBasedExporterMapper.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/AbstractActionManagerBasedExporterMapper.java	(revision 39157)
@@ -1,11 +1,10 @@
 package eu.dnetlib.iis.export.actionmanager;
 
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_ACTION_BUILDER_FACTORY_CLASSNAME;
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_ACTION_SETID;
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_ACTION_SET_PROPERTY_SEPARATOR;
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_SKIP_AUTHORS;
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_SKIP_ORIGINAL_METADATA;
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_TRUST_LEVEL;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_BUILDER_FACTORY_CLASSNAME;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_SETID;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ALGORITHM_PROPERTY_SEPARATOR;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_TRUST_LEVEL;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_TRUST_LEVEL_THRESHOLD;
 
 import java.io.IOException;
 import java.lang.reflect.Constructor;
@@ -26,9 +25,10 @@
 import eu.dnetlib.iis.export.actionmanager.cfg.StaticConfigurationProvider;
 import eu.dnetlib.iis.export.actionmanager.module.ActionBuilderFactory;
 import eu.dnetlib.iis.export.actionmanager.module.ActionBuilderModule;
-import eu.dnetlib.iis.export.actionmanager.module.ActionSetIdProvider;
-import eu.dnetlib.iis.export.actionmanager.module.ActionSetMappingNotDefinedException;
+import eu.dnetlib.iis.export.actionmanager.module.AlgorithmMapper;
 import eu.dnetlib.iis.export.actionmanager.module.AlgorithmName;
+import eu.dnetlib.iis.export.actionmanager.module.MappingNotDefinedException;
+import eu.dnetlib.iis.export.actionmanager.module.TrustLevelThresholdExceededException;
 
 /**
  * ActionManager service based exporter mapper.
@@ -38,7 +38,6 @@
 public abstract class AbstractActionManagerBasedExporterMapper 
 extends Mapper<AvroKey<? extends SpecificRecordBase>, NullWritable, NullWritable, NullWritable> {
 	
-//	private String predefinedTrust = SpecialTrust.NEUTRAL.name();
 	private String predefinedTrust = "0.9";
 	
 	private ActionManagerServiceFacade actionManager;
@@ -45,9 +44,11 @@
 	
 	private ActionManagerConfigurationProvider configProvider;
 	
+	private ActionBuilderFactory<SpecificRecordBase> actionBuilderFactory;
+	
 	private ActionBuilderModule<SpecificRecordBase> actionBuilder;
 	
-	private ActionSetIdProvider actionSetIdProvider;
+	private AlgorithmMapper<String> actionSetIdProvider;
 
 	
 	/** This is the place you can access map-reduce workflow node parameters */
@@ -55,39 +56,24 @@
 	@Override
 	protected void setup(Context context) throws IOException,
 			InterruptedException {
-		
 		if (context.getConfiguration().get(
 				EXPORT_TRUST_LEVEL)!=null) {
 			this.predefinedTrust = context.getConfiguration().get(
 					EXPORT_TRUST_LEVEL);
 		}
-		
-		@SuppressWarnings("unused")
-		boolean skipOriginalMetadata = true;
-		if (context.getConfiguration().get(
-				EXPORT_SKIP_ORIGINAL_METADATA)!=null) {
-			skipOriginalMetadata = Boolean.valueOf(context.getConfiguration().get(
-					EXPORT_SKIP_ORIGINAL_METADATA));	
-		}
-		
-		@SuppressWarnings("unused")
-		boolean skipExportingAuthors = true;
-		if (context.getConfiguration().get(
-				EXPORT_SKIP_AUTHORS)!=null) {
-			skipExportingAuthors = Boolean.valueOf(context.getConfiguration().get(
-					EXPORT_SKIP_AUTHORS));	
-		}
+
 		String moduleClassName = context.getConfiguration().get(
 				EXPORT_ACTION_BUILDER_FACTORY_CLASSNAME);
 		if (moduleClassName!=null) {
 			try {
-				actionSetIdProvider = provideAlgorithmToActionSetMap(context);
+				actionSetIdProvider = provideAlgorithmToActionSetMapper(context);
 				Class<?> clazz = Class.forName(moduleClassName);
 				Constructor<?> constructor = clazz.getConstructor();
-				ActionBuilderFactory<SpecificRecordBase> actionBuilderFactory = 
-						(ActionBuilderFactory<SpecificRecordBase>) constructor.newInstance();
+				actionBuilderFactory = (ActionBuilderFactory<SpecificRecordBase>) constructor.newInstance();
 				actionBuilder = actionBuilderFactory.instantiate(
-						predefinedTrust, context.getConfiguration());
+						predefinedTrust, provideTrustLevelThreshold(
+								context, actionBuilderFactory.getAlgorithName()), 
+						context.getConfiguration());
 				actionManager = buildActionManager(context);
 				configProvider = new StaticConfigurationProvider(
 						StaticConfigurationProvider.AGENT_DEFAULT,
@@ -107,7 +93,33 @@
 		}
 	}
 
-	private ActionSetIdProvider provideAlgorithmToActionSetMap(Context context) {
+	/**
+	 * Provides trust level threshold if defined for given algorithm or globally.
+	 * @param context
+	 * @param algorithmName
+	 * @return trust level threshold or null if not defined
+	 */
+	private Float provideTrustLevelThreshold(Context context, AlgorithmName algorithmName) {
+		String algorithmTrustLevelThreshold = context.getConfiguration().get(
+				EXPORT_TRUST_LEVEL_THRESHOLD + EXPORT_ALGORITHM_PROPERTY_SEPARATOR + 
+				algorithmName.name());
+		if (algorithmTrustLevelThreshold!=null && 
+				!WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(
+						algorithmTrustLevelThreshold)) {
+			return Float.valueOf(algorithmTrustLevelThreshold);	
+		}
+		String defaultTrustLevelThresholdStr = context.getConfiguration().get(
+				EXPORT_TRUST_LEVEL_THRESHOLD);
+		if (defaultTrustLevelThresholdStr!=null && 
+				!WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(
+						defaultTrustLevelThresholdStr)) {
+			return Float.valueOf(defaultTrustLevelThresholdStr);	
+		}
+//		fallback: threshold was not defined
+		return null;
+	}
+	
+	private AlgorithmMapper<String> provideAlgorithmToActionSetMapper(Context context) {
 		String defaultActionSetId = null;
 		if (context.getConfiguration().get(EXPORT_ACTION_SETID)!=null && 
 				!WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(
@@ -117,7 +129,7 @@
 		}
 		final Map<AlgorithmName, String> algoToActionSetMap = new HashMap<AlgorithmName, String>();
 		for (AlgorithmName currentAlgorithm : AlgorithmName.values()) {
-			String propertyKey = EXPORT_ACTION_SETID + EXPORT_ACTION_SET_PROPERTY_SEPARATOR + 
+			String propertyKey = EXPORT_ACTION_SETID + EXPORT_ALGORITHM_PROPERTY_SEPARATOR + 
 					currentAlgorithm.name();
 			if (context.getConfiguration().get(propertyKey)!=null && 
 					!WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(
@@ -129,10 +141,10 @@
 						defaultActionSetId);
 			}
 		}
-		return new ActionSetIdProvider() {
+		return new AlgorithmMapper<String>() {
 			@Override
-			public String getActionSetId(AlgorithmName algorithmName)
-					throws ActionSetMappingNotDefinedException {
+			public String getValue(AlgorithmName algorithmName)
+					throws MappingNotDefinedException {
 				String actionSetId = algoToActionSetMap.get(algorithmName);
 				if (actionSetId!=null && 
 						!WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(
@@ -139,7 +151,7 @@
 								actionSetId)) {
 					return actionSetId;
 				} else {
-					throw new ActionSetMappingNotDefinedException(
+					throw new MappingNotDefinedException(
 							"no action set identifier defined "
 							+ "for algorithm: " + algorithmName.name());
 				}
@@ -161,8 +173,12 @@
 	 * @return personBuilder of actions
 	 */
 	protected List<AtomicAction> createActions(SpecificRecordBase datum) {
-		return actionBuilder.build(datum, configProvider.provideAgent(),
-				actionSetIdProvider.getActionSetId(actionBuilder.getAlgorithName()));
+		try {
+			return actionBuilder.build(datum, configProvider.provideAgent(),
+					actionSetIdProvider.getValue(actionBuilderFactory.getAlgorithName()));
+		} catch (TrustLevelThresholdExceededException e) {
+			return null;
+		}
 	}
 	
 	@Override
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/api/HBaseActionManagerServiceFacade.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/api/HBaseActionManagerServiceFacade.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/api/HBaseActionManagerServiceFacade.java	(revision 39157)
@@ -1,5 +1,9 @@
 package eu.dnetlib.iis.export.actionmanager.api;
 
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_TABLE_NAME;
+
 import java.io.IOException;
 import java.util.ArrayList;
 import java.util.Collection;
@@ -52,7 +56,7 @@
 	public HBaseActionManagerServiceFacade(Configuration hadoopConf,
 			Map<String, String> parameters) throws IOException {
 		String hBaseTableName = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_TABLE_NAME, 
+				EXPORT_ACTION_HBASE_TABLE_NAME, 
 				hadoopConf, parameters);
 		if (hBaseTableName!=null) {
 			hTable = new HTable(
@@ -75,7 +79,7 @@
 		Configuration hbaseConfiguration = HBaseConfiguration.create(hadoopConf);
 //		setting remote zookeeper address for hbase if any set
 		String zookeeperQuorum = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM, 
+				EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM, 
 				hadoopConf, parameters);
 		if (zookeeperQuorum!=null && !zookeeperQuorum.trim().isEmpty() &&
 						!zookeeperQuorum.trim().equals(
@@ -82,7 +86,7 @@
 										WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE)) {
 			hbaseConfiguration.set(HConstants.ZOOKEEPER_QUORUM, zookeeperQuorum.trim());
 			String zookeeperClientPort = ProcessUtils.getParameterValue(
-					WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT, 
+					EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT, 
 					hadoopConf, parameters);
 			if (zookeeperClientPort!=null && !zookeeperClientPort.trim().isEmpty() &&
 							!zookeeperClientPort.trim().equals(
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/entity/document/DocumentExporterProcess.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/entity/document/DocumentExporterProcess.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/entity/document/DocumentExporterProcess.java	(revision 39157)
@@ -1,6 +1,6 @@
 package eu.dnetlib.iis.export.actionmanager.entity.document;
 
-import static eu.dnetlib.iis.common.WorkflowRuntimeParameters.EXPORT_ACTION_SETID;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.*;
 
 import java.io.UnsupportedEncodingException;
 import java.security.InvalidParameterException;
@@ -84,24 +84,24 @@
 			Map<String, String> parameters) throws Exception {
 		FileSystem fs = FileSystem.get(conf);
 		String mdStoreLocation = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.IMPORT_DOCUMENT_MDSTORE_SERVICE_LOCATION, 
+				IMPORT_DOCUMENT_MDSTORE_SERVICE_LOCATION, 
 				conf, parameters);
 		String mdStoreId = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.IMPORT_DOCUMENT_MDSTORE_ID, 
+				IMPORT_DOCUMENT_MDSTORE_ID, 
 				conf, parameters);
 		String actionSetId = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.EXPORT_ACTION_SETID, 
+				EXPORT_ACTION_SETID, 
 				conf, parameters);
 		
 		if (mdStoreLocation==null || WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(mdStoreLocation)) {
 			throw new InvalidParameterException("unable to export document entities to action manager, " + 
 					"unknown MDStore service location. "
-					+ "Required parameter '" + WorkflowRuntimeParameters.IMPORT_DOCUMENT_MDSTORE_SERVICE_LOCATION + "' is missing!");
+					+ "Required parameter '" + IMPORT_DOCUMENT_MDSTORE_SERVICE_LOCATION + "' is missing!");
 		}
 		if (mdStoreId==null || WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(mdStoreId)) {
 			throw new InvalidParameterException("unable to export document entities to action manager, " +
 					"unknown MDStore identifier. "
-					+ "Required parameter '" + WorkflowRuntimeParameters.IMPORT_DOCUMENT_MDSTORE_ID + "' is missing!");
+					+ "Required parameter '" + IMPORT_DOCUMENT_MDSTORE_ID + "' is missing!");
 		}
 		if (actionSetId==null || WorkflowRuntimeParameters.UNDEFINED_NONEMPTY_VALUE.equals(actionSetId)) {
 			throw new RuntimeException("unable to export document entities to action manager, " +
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/test/java/eu/dnetlib/iis/export/actionmanager/ExternalHbaseConnectionTestProcess.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/test/java/eu/dnetlib/iis/export/actionmanager/ExternalHbaseConnectionTestProcess.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/test/java/eu/dnetlib/iis/export/actionmanager/ExternalHbaseConnectionTestProcess.java	(revision 39157)
@@ -1,5 +1,8 @@
 package eu.dnetlib.iis.export.actionmanager;
 
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT;
+import static eu.dnetlib.iis.export.actionmanager.ExportWorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM;
+
 import java.io.InputStream;
 import java.util.Collections;
 import java.util.Iterator;
@@ -51,7 +54,7 @@
 		
 //		setting remote zookeeper address for hbase if any set
 		String zookeeperQuorum = ProcessUtils.getParameterValue(
-				WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM, 
+				EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM, 
 				conf, parameters);
 		if (zookeeperQuorum!=null && !zookeeperQuorum.trim().isEmpty() &&
 						!zookeeperQuorum.trim().equals(
@@ -60,7 +63,7 @@
 //			hbaseConfiguration.set("ha.zookeeper.quorum", zookeeperQuorum.trim());
 			System.out.println("zookeeper quorum set to: " + zookeeperQuorum.trim());
 			String zookeeperClientPort = ProcessUtils.getParameterValue(
-					WorkflowRuntimeParameters.EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT, 
+					EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT, 
 					conf, parameters);
 			if (zookeeperClientPort!=null && !zookeeperClientPort.trim().isEmpty() &&
 							!zookeeperClientPort.trim().equals(
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/test/java/eu/dnetlib/iis/export/actionmanager/module/CitationsActionBuilderModuleFactoryTest.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/test/java/eu/dnetlib/iis/export/actionmanager/module/CitationsActionBuilderModuleFactoryTest.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/test/java/eu/dnetlib/iis/export/actionmanager/module/CitationsActionBuilderModuleFactoryTest.java	(revision 39157)
@@ -27,11 +27,13 @@
 		SortedSet<BlobCitationEntry> sortedCitations = new TreeSet<BlobCitationEntry>();
 		
 		CitationEntry.Builder rawTextCitationEntryBuilder = CitationEntry.newBuilder();
+		rawTextCitationEntryBuilder.setPosition(44);
 		rawTextCitationEntryBuilder.setRawText("[44] S. Mukhi and R. Nigam, “Constraints on ’rare’ dyon decays,” JHEP 12 (2008) 056, 0809.1157.");
 		rawTextCitationEntryBuilder.setExternalDestinationDocumentIds(Collections.<CharSequence,CharSequence>emptyMap());
 		
 		CitationEntry.Builder internalCitationEntryBuilder = CitationEntry.newBuilder();
 		internalCitationEntryBuilder.setRawText("Rugama, Y., Kloosterman, J. L., Winkelman, A., 2004. Prog. Nucl. Energy 44, 1-12.");
+		internalCitationEntryBuilder.setPosition(100);
 		internalCitationEntryBuilder.setDestinationDocumentId("od______2367::00247be440c2188b82d5905b5b1e22bb");
 		internalCitationEntryBuilder.setConfidenceLevel(0.8f);
 		internalCitationEntryBuilder.setExternalDestinationDocumentIds(Collections.<CharSequence,CharSequence>emptyMap());
@@ -38,6 +40,7 @@
 		
 		CitationEntry.Builder externalPmidCitationEntryBuilder = CitationEntry.newBuilder();
 		externalPmidCitationEntryBuilder.setRawText("[5] A. Sen, “Walls of Marginal Stability and Dyon Spectrum in N=4 Supersymmetric String Theories,” JHEP 05 (2007) 039, hep-th/0702141.");
+		externalPmidCitationEntryBuilder.setPosition(5);
 		Map<CharSequence, CharSequence> externalPmidDestinationDocumentIds = new HashMap<CharSequence, CharSequence>();
 		externalPmidDestinationDocumentIds.put("pmid", "20856923");
 		externalPmidCitationEntryBuilder.setExternalDestinationDocumentIds(externalPmidDestinationDocumentIds);
@@ -44,6 +47,7 @@
 		
 		CitationEntry.Builder externalDoiCitationEntryBuilder = CitationEntry.newBuilder();
 		externalDoiCitationEntryBuilder.setRawText("[17] N. Koblitz. Hyperelliptic cryptosystems. J. Cryptology, 1(3):139–150, 1989.");
+		externalDoiCitationEntryBuilder.setPosition(17);
 		Map<CharSequence, CharSequence> externalDoiDestinationDocumentIds = new HashMap<CharSequence, CharSequence>();
 		externalDoiDestinationDocumentIds.put("doi", "10.1186/1753-6561-5-S6-P38");
 		externalDoiDestinationDocumentIds.put("custom-id", "12345");
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/ExportWorkflowRuntimeParameters.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/ExportWorkflowRuntimeParameters.java	(nonexistent)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/ExportWorkflowRuntimeParameters.java	(revision 39157)
@@ -0,0 +1,26 @@
+package eu.dnetlib.iis.export.actionmanager;
+
+public abstract class ExportWorkflowRuntimeParameters {
+
+	private ExportWorkflowRuntimeParameters() {}
+	
+	public static final String EXPORT_TRUST_LEVEL = "export.trust.level";
+	public static final String EXPORT_TRUST_LEVEL_THRESHOLD = "export.trust.level.threshold";
+	
+	public static final String EXPORT_ACTION_SETID = "export.action.setid";
+	public static final String EXPORT_ENTITY_ACTION_SETID = "export.entity.action.setid";
+	
+	public static final char EXPORT_ALGORITHM_PROPERTY_SEPARATOR = '.';	
+	
+	public static final String EXPORT_ACTION_BUILDER_FACTORY_CLASSNAME = "export.action.builder.factory.classname";
+	public static final String EXPORT_ACTION_HBASE_TABLE_NAME = "export.action.hbase.table.name";
+	public static final String EXPORT_ACTION_HBASE_TABLE_INITIALIZE = "export.action.hbase.table.initialize";
+	public static final String EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_QUORUM = "export.action.hbase.remote.zookeeper.quorum";
+	public static final String EXPORT_ACTION_HBASE_REMOTE_ZOOKEEPER_CLIENTPORT = "export.action.hbase.remote.zookeeper.clientport";
+	
+	public static final String EXPORT_DOCUMENTSSIMILARITY_THRESHOLD = "export.documentssimilarity.threshold";
+	
+	public static final String IMPORT_DOCUMENT_MDSTORE_SERVICE_LOCATION = "import.document.mdstore.service.location";
+	public static final String IMPORT_DOCUMENT_MDSTORE_ID = "import.document.mdstore.id";
+	public static final String IMPORT_DATACITE_MDSTORE_SERVICE_LOCATION = "import.datacite.mdstore.service.location";
+}

Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/CitationsActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/CitationsActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/CitationsActionBuilderModuleFactory.java	(revision 39157)
@@ -46,9 +46,11 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
+		 * @param trustLevelThreshold
 		 */
-		public CitationActionBuilderModule(String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+		public CitationActionBuilderModule(String predefinedTrust, 
+				Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -116,22 +118,18 @@
 				return null;
 			}
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<Citations> instantiate(String predefinedTrust,
-			Configuration config) {
-		return new CitationActionBuilderModule(predefinedTrust);
+			Float trustLevelThreshold, Configuration config) {
+		return new CitationActionBuilderModule(predefinedTrust, trustLevelThreshold);
 	}
 	
 	public static BlobCitationEntry build(CitationEntry entry, float confidenceToTrustLevelFactor) {
 		BlobCitationEntry result = new BlobCitationEntry(
 				entry.getRawText()!=null?entry.getRawText().toString():null);
+		result.setPosition(entry.getPosition());
 		if (entry.getDestinationDocumentId()!=null) {
 			result.setIdentifiers(new ArrayList<TypedId>());
 			result.getIdentifiers().add(new TypedId(
@@ -156,4 +154,8 @@
 		return result;
 	}
 
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDocumentClassesActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDocumentClassesActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/DocumentToDocumentClassesActionBuilderModuleFactory.java	(revision 39157)
@@ -38,8 +38,8 @@
 		 * @param predefinedTrust
 		 */
 		public DocumentToDocumentClassesActionBuilderModule(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -126,7 +126,11 @@
 			List<StructuredProperty> result = new ArrayList<StructuredProperty>();
 			for (eu.dnetlib.iis.documentsclassification.schemas.DocumentClass current : source) {
 				if (current!=null) {
-					result.add(convertAvroToProtoBuff(current, taxonomyName));	
+					try {
+						result.add(convertAvroToProtoBuff(current, taxonomyName));
+					} catch (TrustLevelThresholdExceededException e) {
+//						no need to log, we just do not attach result
+					}	
 				}
 			}
 			return result;
@@ -134,7 +138,7 @@
 	//	
 		private StructuredProperty convertAvroToProtoBuff(
 				eu.dnetlib.iis.documentsclassification.schemas.DocumentClass source,
-				String taxonomyName) {
+				String taxonomyName) throws TrustLevelThresholdExceededException {
 			if (source!=null && source.getClassLabels()!=null && source.getClassLabels().size()>0) {
 				StructuredProperty.Builder builder = StructuredProperty.newBuilder();
 				Qualifier.Builder qualifierBuilder = Qualifier.newBuilder();
@@ -159,17 +163,17 @@
 				return null;
 			}
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentToDocumentClasses> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentToDocumentClassesActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AuthorToAuthorStatisticsActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AuthorToAuthorStatisticsActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AuthorToAuthorStatisticsActionBuilderModuleFactory.java	(revision 39157)
@@ -40,11 +40,11 @@
 		/**
 		 * Default constructor.
 		 * @param predefinedTrust
-		 * @param actionSetId
+		 * @param trustLevelThreshold
 		 */
 		private AuthorToAuthorStatisticsActionBuilderModule(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust, Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -86,11 +86,6 @@
 	//		fallback
 			return null;	
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
 	}
 	
 	/**
@@ -115,9 +110,14 @@
 
 	@Override
 	public ActionBuilderModule<AuthorToAuthorStatistics> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new AuthorToAuthorStatisticsActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 
 }
Index: modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AbstractDocumentToConceptsActionBuilderModuleFactory.java
===================================================================
--- modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AbstractDocumentToConceptsActionBuilderModuleFactory.java	(revision 39156)
+++ modules/icm-iis-export-actionmanager/branches/IIS-CDH-5.3.0/src/main/java/eu/dnetlib/iis/export/actionmanager/module/AbstractDocumentToConceptsActionBuilderModuleFactory.java	(revision 39157)
@@ -25,7 +25,7 @@
 public abstract class AbstractDocumentToConceptsActionBuilderModuleFactory 
 	implements ActionBuilderFactory<DocumentToConceptIds> {
 
-	private final AlgorithmName algorithmName;
+	protected final AlgorithmName algorithmName;
 	
 	/**
 	 * Default constructor.
@@ -44,8 +44,8 @@
 		 * @param predefinedTrust
 		 */
 		public DocumentToConceptsActionBuilderModule(
-				String predefinedTrust) {
-			super(predefinedTrust, algorithmName);
+				String predefinedTrust,  Float trustLevelThreshold) {
+			super(predefinedTrust, trustLevelThreshold, algorithmName);
 		}
 	
 		@Override
@@ -95,17 +95,18 @@
 //			fallback
 			return null;
 		}
-		
-		@Override
-		public AlgorithmName getAlgorithName() {
-			return algorithmName;
-		}
+
 	}
 
 	@Override
 	public ActionBuilderModule<DocumentToConceptIds> instantiate(
-			String predefinedTrust, Configuration config) {
+			String predefinedTrust, Float trustLevelThreshold, Configuration config) {
 		return new DocumentToConceptsActionBuilderModule(
-				predefinedTrust);
+				predefinedTrust, trustLevelThreshold);
 	}
+	
+	@Override
+	public AlgorithmName getAlgorithName() {
+		return algorithmName;
+	}
 }
